ArrayList balls = new ArrayList();

void setup()
{
	size(980,500);
	background(100);
}

void draw(){
  background(255);
  if(balls.size() > 0){
    for(int i = 0; i < balls.size(); i++){
	  	balls.get(i).update();
		balls.get(i).draw();
	}
  }else{
    for(int i = 0; i < 100; i++){
	  	  balls.add(new Rectangle(random(980),random(500),0,1));
	}

  }
}

void mouseClicked(){
   Rectangle b = new Rectangle(mouseX,mouseY,0,1);
   balls.add(b);
}
class Rectangle{
  int x, y;
  int yV;
  int xV;
  int xG;
  int yG;
  Rectangle(int initX, int initY, int initXG, int initYG){
    x = initX;
	y = initY;
	xG = initXG;
	yG = initYG;
  }
  void draw(){
    fill(128,128,128);
	stroke(255,255,255);
    beginShape();
	vertex(x+10,y-10);
	vertex(x+10,y+10);
	vertex(x-10,y+10);
	vertex(x-10,y-10);
	endShape(CLOSE);
  }
  void update(){
    yV += yG;
	y += yV;
	xV += xG;
	x += xV;
	if(y > 500){
	  y = 500;
	  yV = -yV * 0.80;
	}
	if(x > 980){
	  x = 980;
	  xV = -xV * 0.80;
	}
	if(y < 0){
	  y = 0;
	  yV = -yV * 0.80;
	}
	if(x < 0){
	  x = 0;
	  xV = -xV * 0.80;
	}
  }
}

class Ball{
  int x, y;
  int yV;
  int gravity;
  Ball(int initX, int initY){
    x = initX;
	y = initY;
	gravity = 1;
  }
  void draw(){
    fill(255,0,0);
	stroke(255,0,0);
    ellipse(x,y,100,100);
  }
  void update(){
  	   yV += gravity;
	   y += yV;
	   if(y > 500){
	     y = 500;
	     yV = -yV * 0.99;
	   }
  }
}